# Laptops Analysis
 
## Description
This project is designed to analyze data on each laptop brands, models etc. visualize it using graphs such as Histogram, Boxplot, Pie chart Bar graph and provide detailed information to help users make informed decisions when purchasing a laptop.

**demonstration link:** [https://youtu.be/YT9EgYnwkaI](https://youtu.be/Gp78YdVAVYo)
![alt text](appimage1.png)
![alt text](appimage2.png)


## Data Sources
My database for this application from Kaggle.com
[Laptop Specs and latest price | Kaggle](https://www.kaggle.com/datasets/kuchhbhi/latest-laptop-price-list)
 
## Running the Application
Any python text editor and go to main.py and run it
 
## Design
#### Class describe
- **Reader class:** Was created for the purpose of the CSV file and changed to Pandas DataFrame, including basic data cleaning.
- **Analysis class:**  Was created for the purpose of working backend behind the calculation system by PandasDataFrame. Include creating a graph before being presented in the frontend system.
- **GuiTools:** Was created to make the Class GUI work easier, such as creating a repeated window TopLevel template and Combobox
- **GUI:** Was built to bring the information that has been processed and presented with GUI (Tkinter)
![alt text](Class_diagram.png)
![alt text](Sequence_diagram_of_scenario.png)
 
## Design Patterns Used
I use the Facade design pattern in a**GUI class** that utilizes many other classes. Additionally, I employ the Singleton design pattern in several classes to facilitate their usage without the need to create objects first. For example, the **Reader class** is included in this approach.
 
## Graph Algorithm Used
![alt text](6510545721Graph_of_Brands_and_Models.png)
If the user wishes to check for a specific model within a laptop brand, to solve this problem we model the trade sequence problem as a graph problem as following:

**Vertex:**
Brand vertice: This vertice represents the chosen laptop brand. There may be multiple edges leading out of this vertice, each representing a different model offered by the brand. Assume it A
Model vertice: Each edge leading out of the brand vertice can lead to a different model vertice, representing the specific laptop model the user is interested in. Assume it B

**Edges:** There is a undirected edge A to B (A–B) When A(Laptop brand) have a B (Model)

associate values: We do not need to associate additional values with the vertices or edges.

**Problem:** Given a graph G and vertices A, B in G, is there a path from A to B?

**Algorithm to solve:**
We can solve this problem using Reachability,
WhateverFirstSearch from A, and check whether B is marked

**Running time:** O(Vertex+Edge) = O(V+E)

 
## Other Information
**Used module**
- tkinter
- tkinter.ttk
- pandas
- pandastable
- matplotlib.backends.backend_tkagg
- networkx
